list of differences between the web GUI client and the original 4GL Windows GUI environment
Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stabilization for GUI   

billable: No case_num:  

vendor_id: GCD   

Description

Related issues:

Related to User Interface - Feature #1811: implement the AJAX client driver Closed 11/01/2013 03/06/2014

Related to User Interface - Support #2674: list of HTML5, CSS and Javascript ... New

History

#1 - 09/01/2015 03:30 PM - Greg Shah

Please add to this list whenever you find something that is a permanent restriction.

1. The font rendering will be close but will not be a pixel-for-pixel duplicate of the Windows font rendering.  To resolve this we would have to

implement our own font rendering engine that duplicated the Windows font rendering engine.  This is not planned at this time and it is believed it is not

needed so long as our rendering is close enough that users cannot tell the difference during use.

2. The default icon is a GCD logo instead of the OpenEdge logo.  We don't want to duplicate their logo because it would confuse the user into thinking

this is OpenEdge code.  That would violate trademark law and copying the logo would violate copyright law.

3. There is no OpenEdge splash screen.  We could make our own but there doesn't seem to be a functional reason to do so.

4. The cursors being used don't exactly match the sets used in Windows.  This could be resolved, but again there is little reason to do so.

5. Menus (fixed and popup), combo-box drop-downs and any other windows that can display outside of the strict boundary of the 4GL application

windows, will only display within the browser.  The page in the browser will be a kind of virtual desktop which can be scrolled so that any such content

can be seen.

6. Clipboard limitations (expand the details here when the final development is done).

7. Some browsers capture certain accelerator keys for browser functions.  Those key combinations cannot be used for application purposes.

#2 - 01/21/2016 07:59 AM - Sergey Ivanovskiy

Firefox shortcuts are  

https://support.mozilla.org/en-US/kb/keyboard-shortcuts-perform-firefox-tasks-quickly?redirectlocale=en-US&as=u&redirectslug=Keyboard+shortcuts
Chrome shortcuts are https://support.google.com/chrome/answer/157179?hl=en

The following table lists all shortcuts that can't be prevented by the modern 43.0.4 Firefox

1. PrtScr/SysRq print screen key

2. Alt + F4     opens close window warning dialog

3. Ctrl + Shift + PAGE UP move tab in focus left but generates Progress 4GL code - 3067 correctly

4. Ctrl + Shift + PAGE DOWN move tab in focus right but generates Progress 4GL code - 3068 correctly

5. Alt opens the browser's menu but generates Progress 4GL code - 1024 correctly

6. Alt + F opens File menu

7. Alt + S opens History menu

8. Alt + V opens View menu

9. Alt + B opens Bookmarks menu

10. Alt + T opens Tools menu

11. Alt + H opens Help menu

The following table lists all shortcuts that can't be prevented by the modern Chromium Version 47.0.2526.106 Ubuntu 15.10 (64-bit)

1. PrtScr/SysRq print screen key

2. Alt + F4 close the window without warning dialog

3. Ctrl + W close the current page without warning dialog

4. Ctrl + T opens a new tab

5. Ctrl + N opens a new window

6. Ctrl + Shift + N opens a new window in incognito mode

IE 11 shortcuts can be found in https://support.microsoft.com/en-us/kb/306832.

The following table lists all shortcuts that can't be prevented by the modern IE 11 Version: 11.0.9600.18124 OS: Windows 7 Service Pack 1

1. PrtScr/SysRq print screen

2. Alt + F4     close the window without warning dialog

3. Alt + Home   go to a home page

4. Alt opens the browser's menu but generates Progress 4GL code - 1024 correctly

5. Alt + F opens File menu

6. Alt + E opens Edit menu

7. Alt + V opens View menu

8. Alt + A opens Favorites menu

9. Alt + T opens Tools menu

10. Alt + H opens Help menu

11. F1 opens Microsoft Help & Support page but generates Progress 4GL code - 301 correctly

12. Alt + D focuses and selects the url in the address bar.

13. Ctrl+ O opens New Document Address Dialog

14. Alt + Z opens Add To Favorites menu but if repeat Alt+Z generates Progress 4GL code - 1114 correctly

15. Alt + C opens View favorites but generates Progress 4GL code - 1091 correctly

These results have been checked manually with test.html, keystrokes.js, keyboard_testcases.js from testcases/uast/keyboard/web and the current

version p2j.keymap.js and p2j.keyboard.js from 1811t by pressing the functional shortcuts in the input field.
#3 - 01/21/2016 10:25 AM - Sergey Ivanovskiy

- File internet_explorer_11_keyboard_shortcuts.docx added

#4 - 01/21/2016 01:30 PM - Sergey Ivanovskiy

- File deleted (internet_explorer_11_keyboard_shortcuts.docx)

#5 - 01/26/2016 06:45 AM - Sergey Ivanovskiy

Firefox doesn't generate key events for some simultaneously pressed keys if the left and right control are hold. For example,

CTRL + CTRL + Z, CTRL + CTRL + X, CTRL + CTRL + C, CTRL + CTRL + V, CTRL + CTRL + Enter, CTRL + CTRL + Delete, CTRL + CTRL +

Insert, CTRL + CTRL + Home, CTRL + CTRL + Page Up, CTRL + CTRL + Num Lock

keydown  keyCode=17        which=17        charCode=0        

         shiftKey=false ctrlKey=false altKey=false metaKey=false

         key=Control char=undefined location=1 repeat=false

keydown  keyCode=17        which=17        charCode=0        

         shiftKey=false ctrlKey=true  altKey=false metaKey=false

         key=Control char=undefined location=2 repeat=false

keyup    keyCode=17        which=17        charCode=0        

         shiftKey=false ctrlKey=true  altKey=false metaKey=false

         key=Control char=undefined location=1 repeat=false

keyup    keyCode=17        which=17        charCode=0        

         shiftKey=false ctrlKey=true  altKey=false metaKey=false

         key=Control char=undefined location=2 repeat=false   

CTRL + CTRL + Page Down invokes the default action - to move to the page right with these logged events:

keydown  keyCode=17        which=17        charCode=0        

         shiftKey=false ctrlKey=false altKey=false metaKey=false

         key=Control char=undefined location=1 repeat=false

keydown  keyCode=17        which=17        charCode=0        

         shiftKey=false ctrlKey=true  altKey=false metaKey=false

         key=Control char=undefined location=2 repeat=false

keydown  keyCode=34  (")   which=34  (")   charCode=0        

         shiftKey=false ctrlKey=true  altKey=false metaKey=false

         key=PageDown char=undefined location=0 repeat=false

Don't know if it is the OS keyboard driver issue or not.
#6 - 03/08/2016 01:44 PM - Sergey Ivanovskiy

The current implementation of the GUI web client redirects to the login page if a user executes the reload/refresh command. It has been done

intentionally and the reload/refresh default action can be restored as soon as the application state API is ready.

To reload the application page it needs to focus the address bar and press F5 or equivalent key strokes. The warning dialog appears before the page

has been reloaded. If a user confirms to leave the current page, then the web page is reloaded, the new web socket connection is opened and then

the web page is redirected to the login page and the web socket server peer gets the QUIT command. On receiving QUIT it terminates the own

worker process to give a user to create new session with P2j server via the web access.

#7 - 03/31/2016 12:45 PM - Greg Shah

- Parent task deleted (#1811)

- Target version changed from Milestone 12 to Milestone 16

#8 - 11/16/2016 12:23 PM - Greg Shah

- Target version changed from Milestone 16 to Cleanup and Stabilization for GUI

#9 - 02/20/2024 05:12 AM - Greg Shah

- Related to Support #2674: list of HTML5, CSS and Javascript features in use in the web client (both ChUI and GUI) + minimum browser levels added
